<template>
  <div v-if="attributes === null">Waiting...</div>
  <div v-else class="w-full">
    <div class="pt-2 pb-4">
      Choose an attribute to inspect:
    </div>
    <div
      v-for="attributeName in attributeNames"
      :key="attributeName"
      :class="{ 'bg-grey-lighter': selectedAttribute === attributeName }"
      class="border p-4 hover:bg-grey-lightest"
      @click="changeSelectedAttribute(attributeName)"
    >
      {{ attributeName | removeQuestionnaireCode }}
      <small class="text-grey-darker">
        (relevance
        <strong>{{ fieldRelevance[attributeName].toFixed(3) }}</strong
        >)
      </small>
      <p
        v-if="selectedAttribute === attributeName"
        class="mt-4 text-sm font-light text-grey-darker"
      >
        {{ fieldDescriptions[attributeName] | removeQuestionnaireCode }}
      </p>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";

export default {
  filters: {
    removeQuestionnaireCode(value) {
      return value.replace(/Q[^_]*_/, "");
    }
  },
  computed: {
    ...mapState([
      "attributes",
      "selectedAttribute",
      "fieldDescriptions",
      "fieldRelevance"
    ]),

    attributeNames() {
      return Object.keys(this.attributes).filter(
        name => name !== "participant_code"
      );
    }
  },
  methods: {
    ...mapActions(["changeSelectedAttribute"])
  }
};
</script>
